claw::graphic::jpeg Class Reference

A class for jpeg pictures. More...

`#include <jpeg.hpp>`

Inheritance diagram for claw::graphic::jpeg:

## Classes

struct | error_manager
| Error handler that throw an exception instead of exiting the program. More...
class | reader
| This class read data from a jpeg file and store it in an image. More...
class | writer
| This class write an image in a jpeg file. More...

## Public Member Functions

| jpeg (unsigned int w, unsigned int h)
| Constructor. Creates an empty image.
| jpeg (const image &that)
| Copy constructor.
| jpeg (std::istream &f)
| Constructor. Load an image from a jpeg file.
void | save (std::ostream &os, const writer::options &opt=writer::options()) const
| Save the image.
Public Member Functions inherited from claw::graphic::image
| image ()
| Constructor. Creates an image without datas.
| image (unsigned int w, unsigned int h)
| Constructor. Creates an empty image.
| image (std::istream &f)
| Constructor. Reads an image from an input stream.
void | swap (image &that)
| Swap the content of two images.
unsigned int | width () const
| Gets image's width.
unsigned int | height () const
| Gets image's height.
scanline & | operator[] (unsigned int i)
| Gets a line of the image.
const scanline & | operator[] (unsigned int i) const
| Gets a line of the image.
iterator | begin ()
| Get an iterator pointing on the first pixel.
iterator | end ()
| Get an iterator pointing just past the last pixel.
const_iterator | begin () const
| Get an iterator pointing on the first pixel.
const_iterator | end () const
| Get an iterator pointing just past the last pixel.
void | merge (const image &that)
| Merge an image on the current image.
void | merge (const image &that, const math::coordinate_2d< int > &pos)
| Merge an image on the current image.
void | partial_copy (const image &that, const math::coordinate_2d< int > &pos)
| Copy an image on the current image.
void | flip ()
| Set the image upside down.
void | fill (const math::rectangle< int > r, const pixel_type &c)
| Fill an area of the image with a given color.
void | set_size (unsigned int w, unsigned int h)
| Set a new size to the image.
void | load (std::istream &f)
| Read the image from a stream.

## Additional Inherited Members

Public Types inherited from claw::graphic::image
typedef rgba_pixel | pixel_type
| The type representing the colors of the pixels in the image.
typedef base_iterator< image, pixel_type > | iterator
| The type of the iterator on the pixels of the image.
typedef base_iterator< const image, const pixel_type > | const_iterator
| The type of the iterator to access constant pixels.

## Detailed Description

A class for jpeg pictures.

Author
  Julien Jorge

Definition at line 52 of file jpeg.hpp.

## Constructor & Destructor Documentation

## jpeg() [1/3]

claw::graphic::jpeg::jpeg | ( | unsigned int | w,
|  | unsigned int | h )

Constructor. Creates an empty image.

Parameters

  w | Image's width.
  h | Image's height.

Precondition
  w > 0 and h > 0

Definition at line 39 of file jpeg.cpp.

References claw::graphic::image::image().

## jpeg() [2/3]

claw::graphic::jpeg::jpeg | ( | const image & | that | ) |

Copy constructor.

Parameters

  that | Image to copy from.

Definition at line 50 of file jpeg.cpp.

References claw::graphic::image::image().

## jpeg() [3/3]

claw::graphic::jpeg::jpeg | ( | std::istream & | f | ) |

Constructor. Load an image from a jpeg file.

Parameters

  f | Jpeg file.

Definition at line 61 of file jpeg.cpp.

## Member Function Documentation

## save()

void claw::graphic::jpeg::save | ( | std::ostream & | f,
|  | const writer::options & | opt = writer::options() ) const

Save the image.

Parameters

  f | The file in which we write.
  opt | Saving options.

Definition at line 73 of file jpeg.cpp.

The documentation for this class was generated from the following files:

- jpeg.hpp
- code/jpeg.cpp